<?php
require_once 'Constants.php';

class Authentication
{
    const URL_AUTH = Constants::URL_BASE;

    public function login($user, $pass)
    {

        //$this->testeAPI($user, $pass);

        $curl = curl_init();

        $arrAuth = array(
            'email' => $user,
            'senha' => $pass
        );

        curl_setopt_array($curl, array(
            CURLOPT_URL => self::URL_AUTH . '/api/login/universidade',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_2,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($arrAuth),
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json'
            )
        ));

        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);


        $response = curl_exec($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);


        if ($httpcode != 200) {

            throw new Exception('Erro ao realizar autenticação no Altimus');
        }


        $retorno = json_decode($response);

        if (!isset($retorno->status) || $retorno->status != 200) {
            return false;
        };

        if (!isset($retorno->info)) {
            throw new Exception('Nenhum registro encontrado');
        }

        return $retorno->info;
    }


    public function validateToken($email, $token)
    {

        $curl = curl_init();

        $header = [
            'Authorization: Bearer ' . $token,
            'Content-Type: application/json'
        ];
        $arrField['email'] = $email;

        curl_setopt_array($curl, array(
            CURLOPT_URL => self::URL_AUTH . '/api/login/universidade/valida-token',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($arrField),
            CURLOPT_HTTPHEADER => $header,
        ));

        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);


        $response = curl_exec($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);


        if ($httpcode != 200) {
            throw new Exception('Não foi possível autenticar o usuário');
        }

        $retorno = json_decode($response);
        if (!isset($retorno->status) || $retorno->status != 200) {
            return false;
        };

        if (!isset($retorno->info)) {
            throw new Exception('Nenhum registro encontrado');
        }

        return $retorno->info;
    }




    public function testeAPI($user, $pass)
    {


        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => self::URL_AUTH . '/api/login/universidade',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => '{"email":"luciano.ramos@altimus.com.br", "senha": "123"}',
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json'
            ),
        ));


        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);

        $response = curl_exec($curl);
        curl_close($curl);


        $retorno = json_decode($response);



        print_r($retorno);
        die('fim');
    }
}
